function [w, err] = graddescent_vectorized_YL(X, Y, w_init)
  
  w = w_init;
  epsilon = 0.000001;
  
  Niter = 5000;
  
  err = zeros(1,Niter);
  
  for iteration = 1 : Niter %<- in practice, use some stopping criterion!
    %COMPUTE GRADIENT
    grad = 2*sum(repmat(w'*X-Y,size(X,1),1).*X,2);

    %TAKE STEP
    w = w - epsilon * grad;

    %OUTPUT THE CURRENT ERROR
    err(iteration) = sum((Y - w'*X).^2);

  end;
  
end

