function [w, err] = perceptron_YL(X,Y,w_init)

Niter = 100;
  
err = zeros(1,Niter + 1);

w = w_init;

for iteration = 1 : Niter  %<- in practice, use some stopping criterion!
  for ii = 1 : size(X,2)         %cycle through training set
    if sign(w'*X(:,ii)) ~= Y(ii) %wrong decision?
      w = w + X(:,ii) * Y(ii);   %then add (or subtract) this point to w
    end
  end
  err(iteration) = sum(sign(w'*X)~=Y)/size(X,2);   %show misclassification rate
end

end